package nxtplugin;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedList;

import javax.swing.*;
import javax.swing.text.*;

import lejos.pc.comm.NXTCommLogListener;

public class NXTDebug extends JFrame implements NXTCommLogListener {
	private JPanel content;
	private JLabel textAlive, textLost;
	private JTextPane messages;
	private StyledDocument doc;
	private JScrollPane scrollpane;
	private SimpleDateFormat formater;
	protected SortedListModel aliveListModel, lostListModel;
	protected JList aliveList, lostList;
	
	public NXTDebug() {
		super("NXTPlugin - DEBUG");
		
		formater = new SimpleDateFormat("HH:mm:ss");
		
		messages = new JTextPane();
		messages.setEditable(false);
		messages.setContentType("text/html");
		
		doc = messages.getStyledDocument();
		Style style = doc.addStyle("GRAY", null);
		StyleConstants.setForeground(style, Color.GRAY);
		style = doc.addStyle("BLACK", null);
		StyleConstants.setForeground(style, Color.BLACK);
		
		scrollpane = new JScrollPane(messages);
		scrollpane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollpane.setPreferredSize(new Dimension(700, 200));
		scrollpane.setMinimumSize(new Dimension(10, 10));
		
		textAlive = new JLabel("NXTs ALIVE:");
		aliveListModel = new SortedListModel();
		aliveList = new JList(aliveListModel);
		aliveList.setPreferredSize(new Dimension(100,80));
		aliveList.setBorder(BorderFactory.createLineBorder(Color.GRAY, 1));
		
		textLost = new JLabel("NXTs LOST:");
		lostListModel = new SortedListModel();
		lostList = new JList(lostListModel);
		lostList.setPreferredSize(new Dimension(100,80));
		lostList.setBorder(BorderFactory.createLineBorder(Color.GRAY, 1));	
		
		content = new JPanel();
		content.setLayout(new GridBagLayout());		
		GridBagConstraints c = new GridBagConstraints();

		c.gridx = 0;
		c.gridy = 0;
		c.gridheight = 4;
		c.fill = GridBagConstraints.BOTH;
		c.insets = new Insets(5, 5, 5, 5);
		content.add(scrollpane, c);
		
		c.gridx = 1;
		c.gridy = 0;
		c.gridheight = 1;
		c.fill = GridBagConstraints.BOTH;
		c.anchor = GridBagConstraints.SOUTH;
		content.add(textAlive, c);
		
		c.gridx = 1;
		c.gridy = 1;
		c.gridheight = 1;
		c.fill = GridBagConstraints.BOTH;
		c.anchor = GridBagConstraints.NORTHEAST;
		content.add(aliveList, c);
		
		c.gridx = 1;
		c.gridy = 2;
		c.gridheight = 1;
		c.fill = GridBagConstraints.BOTH;
		c.anchor = GridBagConstraints.SOUTH;
		content.add(textLost, c);
		
		c.gridx = 1;
		c.gridy = 3;
		c.gridheight = 1;
		c.fill = GridBagConstraints.BOTH;
		c.anchor = GridBagConstraints.NORTHEAST;
		content.add(lostList, c);
					
		this.setContentPane(content);
		this.pack();
		this.setVisible(true);
	}
	
	public void logEvent(String message) {
		if (doc.getLength() > 0) {
			try {
				doc.insertString(doc.getLength(), "\n", doc.getStyle("regular"));
			} catch (BadLocationException e) {
				e.printStackTrace();
			}
		}
		
		Throwable t = new Throwable();
		
		if (t.getStackTrace()[1].getClassName().equals("nxtplugin.NXTPlugin")) {
			try {
				doc.insertString(doc.getLength(), "[" + formater.format(new Date().getTime()) + "] " + t.getStackTrace()[1].getMethodName() + " -> " + message, doc.getStyle("BLACK"));
			} catch (BadLocationException e) {
				e.printStackTrace();
			}
		}
		else {
			try {
				doc.insertString(doc.getLength(), "[" + formater.format(new Date().getTime()) + "] " + t.getStackTrace()[1].getMethodName() + " -> " + message, doc.getStyle("GRAY"));
			} catch (BadLocationException e) {
				e.printStackTrace();
			}
		}
		
		messages.setCaretPosition(messages.getDocument().getLength());
	}
	
	public void logEvent(Throwable throwable) {
	}
	
	public void addAlive(RemoteNXT nxt) {
		lostListModel.removeElement(nxt);
		aliveListModel.add(nxt);
	}
	
	public void addLost(RemoteNXT nxt) {
		aliveListModel.removeElement(nxt);
		lostListModel.add(nxt);
	}
}
